/* Version 6 - for Borland's Turbo C++ 1.0  */
//	(c) 1990 BP Midi Systems


typedef unsigned char byte;

#ifndef BOOLD
typedef enum BOOL {FALSE=0, TRUE=1};
#define BOOLD
#endif

#define ACK 0xfe
#define UART_MODE 0x3f
#define START_SYSEX 0xf0
#define END_SYSEX 0xf7


#define TIMEOUT 32767
#define MIDI_BUF_SIZE 8192

#define DSR 0x80
#define DRR 0x40
#define MIDI_INTERRUPT 2
#define EOI 0x20
#define PIC_A 0x20
#define PIC_B 0x21

#define MIDI_DATA_PORT 0x330
#define MIDI_CMD_PORT 0x331
#define MIDI_STATUS_PORT 0x331

extern void (*midi_play)(unsigned char);

class ByteQ
{
	public:
		ByteQ(int);
		~ByteQ(void);
		byte get(void);
		void put(byte);
		void flush(void);
		int isQd;		// how many bytes are queued - used BOOL also
	private:
		byte far *qstart, far *qend, far *qhead, far *qtail;
};


class MIDI: public ByteQ
{
	public:
		MIDI(int size);	// constructor
		~MIDI(void);				// destructor
		MIDI& operator << (byte);	// send data
		BOOL operator ()(byte);	    // send cmd
		void Write(byte *,int);
		void wait(void);
		BOOL xfer(byte far *,int);
	protected:
	private:
		BOOL Open;
		void interrupt (*old_int)(...);
};

extern MIDI midi;

