#include<stdio.h>
#include<stdlib.h>
#include<stdarg.h>
#include<conio.h>
#include"ultimate.h"
#include"midi6.h"

char SignOff[][35]={
		"Thanks for using my software.....",
		"Did you have fun ?",
		"Come back soon !",
		"Thanks for using Seq III++"
		};

BOOL 	Playing=FALSE,
		NoteOn=FALSE;

struct text_info ti;

char MidiQ[32], SaveQ[5][32];
int Qptr=0;

GadgAttr ga1={A(WHITE,RED), A(BLACK,RED),
	A(WHITE,BLACK), A(YELLOW,RED)};

// seq group
BoolGadget Metro(4,4,&ga1, "~Metro    ",FALSE);
IntGadget QueueSz(4,6,&ga1,"~QueueSize",8,0,32);
IntGadget Tempo(4,8,&ga1,  "T~empo    ",100,40,240);

Gadget *Group1Gadgets[3]={&Metro,&QueueSz,&Tempo};
GadgetGroup Group1(2,2,A(WHITE,BLUE),"Sequencer",Group1Gadgets, 3 );

// voice group
IntGadget Rechan(28,4,&ga1,   "~Rechan  ",1,1,16);
IntGadget Pgm(28,6,&ga1,      "~Program ",0,0,127);
IntGadget Vel(28,8,&ga1,      "~Velocity",64,0,127);
IntGadget Dur(28,10,&ga1,     "~Duration",15,1,29);

Gadget *Group2Gadgets[4]={&Rechan,&Pgm,&Vel,&Dur};
GadgetGroup Group2(26,2,A(WHITE,CYAN),"Voice",Group2Gadgets, 4 );

// randomizer group external
extern GadgetGroup Group3;

GadgetGroup *Sgroups[3]={&Group1,&Group2,&Group3};
GadgetDialog S(3,7,77,20,A(WHITE,RED)," BP Midi ",Sgroups,3);

Wi Q(3,23,77,35,A(WHITE,MAGENTA),SINGLE);

extern void RandomizeQ(void);

/*-----------------------------------------------------------------------*/

void Msg(char *t)
{
	S(40,12)<<A(WHITE,RED);
	clreol();
	S<<t;
}

void StartPlay(void)
{
	// start midi in play mode track 1 only
	Qptr=0;
	midi(Metro.Value?0x85:0x84);		// metronome on/off
	midi(0xec);		// set active tracks
	midi<<0x01;		// track 1
	midi(0xb8);		// clear play counters
	midi(0x0a);		// start play
	Playing=TRUE;
	S(2,12)<<A(WHITE,LIGHTRED)<<"Playing";
}

void StopPlay(void)
{	midi(0x05);		// stop play
	midi(0x84);		// stop metronome
	Playing=FALSE;
	midi(0xb9);		// clear play map
	midi(0xb8);		// clear play counters
	S(2,12)<<A(WHITE,RED)<<"Stopped";
}

void ProgramChange(Gadget *g)
{
	midi(0xd7);		// want to send data - use track 8
	midi<< (0xc0+Rechan.Value-1) << Pgm.Value;
}

BOOL HandleKeybd(unsigned int c)
{
	switch (c) {
		case 0x0021:		// shift 1
			memcpy(SaveQ[0],MidiQ,sizeof MidiQ);
			Msg("Seq 1 Saved");
			break;

		case 0x0040:		// shift 2
			memcpy(SaveQ[1],MidiQ,sizeof MidiQ);
			Msg("Seq 2 Saved");
			break;

		case 0x0023:		// shift 3
			memcpy(SaveQ[2],MidiQ,sizeof MidiQ);
			Msg("Seq 3 Saved");
			break;

		case 0x0024:		// shift 4
			memcpy(SaveQ[3],MidiQ,sizeof MidiQ);
			Msg("Seq 4 Saved");
			break;

		case 0x0025:		// shift 5
			memcpy(SaveQ[4],MidiQ,sizeof MidiQ);
			Msg("Seq 5 Saved");
			break;

		case 0x0178:		// Shift 1
			while (NoteOn);	// wait till note off
			memcpy(MidiQ,SaveQ[0],sizeof MidiQ);
			Msg("Seq 1 Recalled");
			break;

		case 0x0179:		// Shift 2
			while (NoteOn);	// wait till note off
			memcpy(MidiQ,SaveQ[1],sizeof MidiQ);
			Msg("Seq 2 Recalled");
			break;

		case 0x017a:		// Shift 3
			while (NoteOn);	// wait till note off
			memcpy(MidiQ,SaveQ[2],sizeof MidiQ);
			Msg("Seq 3 Recalled");
			break;

		case 0x017b:		// Shift 4
			while (NoteOn);	// wait till note off
			memcpy(MidiQ,SaveQ[3],sizeof MidiQ);
			Msg("Seq 4 Recalled");
			break;

		case 0x017c:		// Shift 5
			while (NoteOn);	// wait till note off
			memcpy(MidiQ,SaveQ[4],sizeof MidiQ);
			Msg("Seq 5 Recalled");
			break;

		case 0x013c:		// F2 - start/stop play
			if (Playing) StopPlay();
			else StartPlay();
			break;

		case 0x0143:		// F9 - randomize Q
			while (NoteOn);
			RandomizeQ();
			Msg("Seq Randomized");
			break;

		case 0x0144:		// F10 - Exit
			if (Menu(" Quit? ",GREEN,2,"Yes","No")==1) {
				// bye bye
				StopPlay();
				midi.flush();
				window(1,1,80,ti.winbottom);
				textattr(A(LIGHTGRAY,BLACK));
				clrscr();
				_setcursortype(_NORMALCURSOR);
				printf(SignOff[random(sizeof SignOff/35)]);
				exit(0);
			}
			break;
		default:
			return FALSE;
	}
	return TRUE;
}

char Note[][3]={"C ","C#","D ","D#","E ","F ","F#","G ","G#","A ","A#","B "};

void Idle(void)
{
	// this gets called whenever gadgets enters a user idle state


	Q(2+2*Qptr,2)<<
		(!NoteOn?A(WHITE,BLACK):A(WHITE,MAGENTA))<<
		Note[MidiQ[Qptr]%12];


	Q(2+MidiQ[Qptr]%12,MidiQ[Qptr]/12)<<
		A(WHITE,MAGENTA)<<
		(!NoteOn?"":" ");

	while (midi.isQd) midi.get();
}

void InitScreen(void)
{
	textmode(C4350);
	gettextinfo(&ti);
	clrscr();

	_setcursortype(_NOCURSOR);

	Wi bg(1,1,80,ti.winbottom,A(DARKGRAY,BLUE));
	bg.open();
	bg.fill(1,1,80,ti.winbottom,177);

	Wi tbd(8,3,72,5,A(BLACK,BLACK));
	tbd.open();

	Wi t(7,2,71,4,A(WHITE,BLUE),SINGLE);
	t.open();
	t(15,1)<<A(YELLOW,BLUE)<<"BP Midi Sequencer III 1.0 - (c) 1990";

	// FKey Help
	Wi f(3,38,77,40,A(BLACK,LIGHTGRAY),SINGLE);
	f.open(" Function Keys ");
	f<<A(RED,LIGHTGRAY)<<"F1 "<<A(BLACK,LIGHTGRAY)<<"Help  ";
	f<<A(RED,LIGHTGRAY)<<"F2 "<<A(BLACK,LIGHTGRAY)<<"Start/Stop  ";
	f<<A(RED,LIGHTGRAY)<<"F9 "<<A(BLACK,LIGHTGRAY)<<"RndmQ  ";
	f<<A(RED,LIGHTGRAY)<<"F10 "<<A(BLACK,LIGHTGRAY)<<"Exit   ";
	f<<A(RED,LIGHTGRAY)<<"Shft 1-5 "<<A(BLACK,LIGHTGRAY)<<"PutQ  ";
	f<<A(RED,LIGHTGRAY)<<"Alt 1-5 "<<A(BLACK,LIGHTGRAY)<<"GetQ";

	// Q Screen
	Q.open(" Queues ");
}

void MidiPlay(unsigned char c)  // c is the track requesting
{
	if (!QueueSz.Value) {
		midi << 0xf8;		// nill
		return;
	}

	NoteOn=NoteOn?FALSE:TRUE;

	midi << (!NoteOn?Dur.Value:30-Dur.Value) << 	// timing
	(0x90+Rechan.Value-1) <<    // note on + rechan
	MidiQ[Qptr] <<      		// note
	(NoteOn?Vel.Value:0);		// velocity

	if (!NoteOn)
		if (++Qptr > QueueSz.Value-1) Qptr=0; // advance Q

}

void MetroChange(Gadget *g)
{	if (!Playing) return;
	if (Metro.Value) midi(0x85);		// metro on
	else midi(0x84);					// metro off
}

void TempoChange(Gadget *g)
{
	midi(0xe0);
	midi<< Tempo.Value;
}

int main(void)
{
	// initial screen & set up
	InitScreen();

	// gadget user routines
	gadg_idle=Idle;
	gadg_kbd=HandleKeybd;

	// gadget deltas
	Metro.delta=MetroChange;
	Tempo.delta=TempoChange;
	Pgm.delta=ProgramChange;

	// establish play handler
	midi_play=MidiPlay;

	// randomize some notes to start with
	RandomizeQ();

	//invoke Gadgets
	S.open();
	S(2,12)<<A(WHITE,RED)<<"Stopped";
	S.exec();
}
