
/*[]-------------------------------------< Ultimate!  >----------------[]*/

/*
			   Ultimate! Window Routines for TC++
				   (C) 1990 BP Midi Systems
					  (703) 204-1461
*/

#include"ultimate.h"

/*[]-------------------------------------< Globals    >----------------[]*/

int mBack=LIGHTGRAY, mText=BLACK, mHotkey=RED, mSelect=GREEN,
	dBack=BLUE, dText=WHITE;

unsigned char mBoxChr[2][6]={ 	'','','','','','',
								'','','','','',''
			  };

struct text_info ScreenTi;

/*[]-------------------------------------< Funcs      >----------------[]*/

void Wi::box(ushort x1, ushort y1, ushort x2, ushort y2, BOX b)
{
	int i;
	b--;
	gotoxy(x1+1,y1);
	BiosWrt(mBoxChr[b][0],t.attribute,x2-x1-1);
	gotoxy(x1+1,y2);
	BiosWrt(mBoxChr[b][0],t.attribute,x2-x1-1);
	for (i=y1+1;i<y2;i++) {
		gotoxy(x1,i); BiosWrt(mBoxChr[b][1],t.attribute,1);
		gotoxy(x2,i); BiosWrt(mBoxChr[b][1],t.attribute,1);
	}
	gotoxy(x1,y1); BiosWrt(mBoxChr[b][2],t.attribute,1);
	gotoxy(x2,y1); BiosWrt(mBoxChr[b][3],t.attribute,1);
	gotoxy(x1,y2); BiosWrt(mBoxChr[b][4],t.attribute,1);
	gotoxy(x2,y2); BiosWrt(mBoxChr[b][5],t.attribute,1);
}

void Wi::close(void)
{
	if (brdr!=NONE)
		puttext(t.winleft-1,t.wintop-1,t.winright+1,t.winbottom+1,v);
	else
		puttext(t.winleft,t.wintop,t.winright,t.winbottom,v);
	top=FALSE; actv=NULL;
}

void Wi::title(char *ti, int a)
{
	if (brdr!=NONE) {	// can't do it to unbordered windows !

		window(t.winleft-1,t.wintop-1,t.winright+1,t.winbottom+1);
		gotoxy(3,1); BiosWrt(mBoxChr[brdr-1][0],t.attribute,
				t.winright-t.winleft-1);
		textattr(a); gotoxy(3,1); cputs(ti);
		window(t.winleft,t.wintop,t.winright,t.winbottom);
	}
}

Wi *Wi::open(void)
{
	Wi *prev=NULL;
	if (actv) {
		prev=actv;
		actv->deact();
	}
	textattr(t.attribute);
	gettext(t.winleft,t.wintop,t.winright,t.winbottom,v);
	window(t.winleft,t.wintop,t.winright,t.winbottom);
	clrscr();
	if (brdr!=NONE) {
		box(1,1,t.winright-t.winleft+1,t.winbottom-t.wintop+1,brdr);
		window(t.winleft+1,t.wintop+1,t.winright-1,t.winbottom-1);
	}
	gettextinfo(&t);
	actv=this; top=TRUE;
	return prev;
}

Wi *Wi::open(char *T)
{
	Wi *prev;
	prev=open();
	title(T,t.attribute);
	return prev;
}

void Wi::fill(ushort x1, ushort y1, ushort x2, ushort y2, char c)
{
	if (!top) act();
	for (register i=0;i<y2-y1+1;i++) {
		gotoxy(x1,y1+i);
		BiosWrt(c,t.attribute,x2-x1+1);
	}
}

Wi::Wi(ushort x1, ushort y1, ushort x2, ushort y2, attr x, BOX b)
	{
		t.winleft=x1; t.wintop=y1; t.winright=x2; t.winbottom=y2;
		v = (void *) new char [(x2-x1+1)*(y2-y1+1)*2];
		t.attribute=x; brdr=b; top=FALSE;
	}

void Wi::setattr(attr a)
	{
		t.attribute=a;
	}

void Wi::act(void)
	{
		if (actv) actv->deact();
		window(t.winleft,t.wintop,t.winright,t.winbottom);
		gotoxy(t.curx,t.cury);
		actv=this; top=TRUE;
	}

void Wi::deact(void)
	{
		gettextinfo(&t);
		top=FALSE;
		actv=NULL;
	}

Wi::~Wi(void)
	{
		delete v;
		if (top) actv=NULL;
	}

Wi& Wi::operator << (char *s)
	{
		if (!top) act();
		textattr(t.attribute);
		cputs(s);
		return *this;
	}

Wi& Wi::operator << (attr x)
	{
		t.attribute=x;
		return *this;
	}

Wi& Wi::operator()(int x, int y)
	{
		if (!top) act();
		gotoxy(x,y);
		return *this;
	}

unsigned int getchx(void)
{
	int c=getch();
	if (c==0) return(0x0100+getch());
	else return c;
}

int Menu(char *title, int a, int ni, char **item)
{
	char c;
	short wx, wy, ww, wh;
	BOOL menux=FALSE;
	Wi *prev;
	int i,j=0,is=0;

	for (i=0;i<ni;i++)
		is=max(is,strlen(item[i]));

	/* draw centered window */
	wx=39-is/2;
	wy=12-ni/2;
	ww=max(is+4,strlen(title)+4);
	wh=ni+2;

	Wi m(wx, wy, wx+ww, wy+wh, A(WHITE,a),DOUBLE);
	prev=m.open(title);

	/* print choices */

	textcolor(WHITE);
	for (i=0;i<ni;i++)
		m(center(ww,strlen(item[i])),i+2)<<(item[i]);

	/* handle keyboard */
	while (!menux) {
		m(center(ww,strlen(item[j])),j+2)<<A(WHITE,BLACK)<<
			(item[j]);
		c=getch();
		m(center(ww,strlen(item[j])),j+2)<<A(WHITE,a)<<
			(item[j]);
		switch (c) {
			case (0):	/* extended */
				switch (getch()) {
					case(UPARO):
						j=--j<0?ni-1:j;
						break;
					case(DNARO):
						j=++j==ni?0:j;
						break;
				}
				break;
			case(0x1b):	j=-1;
				menux=TRUE;
			case(0x0d):
				menux=TRUE;
			default: if (isascii(c))
				for (i=0;i<ni;i++)
					if (toupper(c)==toupper(*(item[i]))) {
						j=i;
						menux=TRUE;
						break;
					}
		}
	}

	/* return selection */

	m.close();
	if (prev) prev->act();

	return j+1;
}

int Menu(char *title, int a, int ni, ...)
{
	va_list ap;
	// build pointer list
	char **list = new char * [ni];
	va_start(ap,ni);
	for (int i=0;i<ni;i++)
		list[i]=va_arg(ap,char *);
	va_end(ap);
	int rc=Menu(title,a,ni,list);
	delete list;
	return rc;
}


