
/*[]-------------------------------------< Ultimate!  >----------------[]*/

/*
			   Ultimate! Window Routines for TC++
				   (C) 1990 BP Midi Systems
					  (703) 204-1461
*/

#include<conio.h>
#include<dos.h>
#include<stdio.h>
#include<stdlib.h>
#include<stdarg.h>
#include<string.h>
#include<ctype.h>

/*[]-------------------------------------< MACROS     >----------------[]*/

#define A(a,b) (a+(b<<4))
#define SCREENHEIGHT (ScreenTi.winbottom-ScreenTi.wintop)
#define max(a,b) (a>b?a:b)
#define center(a,b) (((a)/2)-((b)/2))

/*[]-------------------------------------< Constants  >----------------[]*/

#define UPARO 0x48
#define DNARO 0x50


/*[]-------------------------------------< Typedefs   >----------------[]*/

#ifndef BOOLD
typedef enum BOOL {FALSE=0, TRUE=1};
#define BOOLD
#endif

typedef unsigned short ushort;
typedef unsigned char attr;

typedef enum BOX {
	NONE,
	SINGLE,
	DOUBLE
	};

/*[]-------------------------------------< Structures >----------------[]*/

struct point {
	unsigned short x,y;
	};

struct GadgAttr {
	int a,b,c,d;
	};


/*[]-------------------------------------< Protos     >----------------[]*/

unsigned int getchx(void);
int Menu(char *title, int a, int ni, char **i);
int Menu(char *title, int a, int ni, ...);
extern "C" {
void BiosWrt(char c, attr a, int reps);
int ShiftStatus(void);
}

/*[]-------------------------------------< Externs    >----------------[]*/

extern unsigned char mBoxChr[2][6];

extern struct text_info ScreenTi;

extern void (*gadg_idle)();
extern BOOL (*gadg_kbd)(unsigned x);

/*[]-------------------------------------< Classes    >----------------[]*/

class Wi
{
  public:
	Wi(ushort, ushort, ushort, ushort, attr, BOX=NONE);
	void setattr(attr);
	Wi *open(void);
	Wi *open(char *);
	void title(char *, int);
	void close(void);
	void box(ushort, ushort, ushort, ushort, BOX);
	~Wi(void);
	Wi& operator << (char *);
	Wi& operator << (attr);
	Wi& operator()(int, int);
	void fill(ushort, ushort, ushort, ushort, char);
	void act(void);
	void deact(void);

  protected:
	static Wi *actv;	// whatever window is active

	BOOL top;			// are we tops?

	void *v;			// gettext, puttext
	struct text_info t; // where we and TC++ store various things
	BOX brdr;

};

class Gadget {		// an abstract class!
	public:
		// constructor
		Gadget(int x1, int y1, struct GadgAttr *g, char *T);
		virtual void operator << (int) = 0; // pure virtual!
		virtual void inc(void) {};
		virtual void dec(void) {};
		void open(void);
		void (*delta)(Gadget *);			// pointer to func when changed
	protected:
		friend class GadgetDialog;
		int x,y;
		char *Title;
		GadgAttr *Attr;
		virtual void Display(void) = 0;	// pure virtual!
		virtual void DisplayTitle(void);
};

class ButtonGadget: public Gadget {
	public:
		ButtonGadget(int x1, int y1, struct GadgAttr *g, char *T, void (*f)(void)):
			Func(f), Gadget(x1,y1,g,T) {}
		void (*Func)();
		void DisplayTitle(void);
		void Display(void) { DisplayTitle(); }
		void operator << (int) {}		// dummy function
};

class BoolGadget: public Gadget {
	public:
		BoolGadget(int x1, int y1, struct GadgAttr *g, char *T, BOOL v):
			Value(v), Gadget(x1,y1,g,T) {}
		BOOL Value;
		virtual void Display(void);
		void operator << (int i) { Value=(i?TRUE:FALSE); Display(); }
		void inc(void);
		void dec(void) { inc(); }		// same for BOOL!
};

class IntGadget: public Gadget {
	public:
		IntGadget(int x1, int y1, struct GadgAttr *g, char *T, int v, int mn, int mx):
			Minimum(mn), Maximum(mx), Value(v), Gadget(x1,y1,g,T) {}
		int Value;
		int Minimum, Maximum;
		void operator << (int i);
		void inc(void);
		void dec(void);
		virtual void Display(void);
};

class ListGadget: public IntGadget {
	public:
		// constructor
		ListGadget(int x1, int y1, struct GadgAttr *g, char *T, int v,
			char **l,int items): list(l), IntGadget(x1,y1,g,T,v,0,items-1) {}
		char **list;
		void Display(void);
};

class AnalogGadget: public IntGadget {
	public:
		// constructor
		AnalogGadget(int x1, int y1, struct GadgAttr *g, char *T, int v, int mn, int mx, int a, int w):
			Width(w), aAttr(a), IntGadget(x1,y1,g,T,v,mn,mx) {}
		int Width;
		int aAttr;
		void Display(void);
};

class HexGadget: public IntGadget {
	public:
		HexGadget(int x1, int y1, struct GadgAttr *g, char *T, int v, int mn, int mx):
			IntGadget(x1,y1,g,T,v,mn,mx) {}
		void Display(void);
};

class GadgetGroup {
	public:
		GadgetGroup(int,int,int,char *,Gadget **,int);
		void open(void);
	protected:
		friend class GadgetDialog;
		int NumberOfGadgets;
		Gadget **GadgetList;	// points to an array!
		int CurrentGadget;
	private:
		int x,y;
		char *Title;
		int GroupAttr;

};

class GadgetDialog: public Wi {
	public:
		GadgetDialog(int,int,int,int,
			int,char *,
			GadgetGroup **,int);
		void open(void);
		void exec(void);
	private:
		int x,y;
		char *Title;
		int NumberOfGroups;
		GadgetGroup **GroupList;	// points to an array!
		int CurrentGroup;
};

/*[]-------------------------------------< End Header >----------------[]*/

